--[[ Changelog:
	1.0 : Initial release
	1.1 : Added "(currently xxx)" to end of "Requires (Fishing, Cooking, etc.)" messages. For example, "Requires Mining 500 (currently 496)"
	1.2 : Added command to print highest herb/mob/mine you can pick/skin/mine, fixed "Requires skinning knife (currently 0)" bug
	1.3 : Updated for 5.0, added Pandaria resources, now takes into account levels gained from enchants and items in bag (Herbalist's Spade, etc.)
	
	-- TODO: add level required (and current) into hover tooltips for herbs/nodes, maybe skinnable mobs
	-- TODO: improve /gn skill output, show current level, mineable, and next minable thing in how many levels
	-- TODO: update skinning levels for 80-90 mobs for mists, i can't quite yet
]]

local mining_levels = {
	{1,   "Copper"},
	{50,  "Tin"},
	{65,  "Silver"},
	{100, "Iron"},
	{115, "Gold"},
	{150, "Mithril"},
	{165, "Truesilver and Dark Iron"},
	{200, "Small Thorium"},
	{215, "Rich Thorium"},
	{275, "Fel Iron"},
	{325, "Adamantite"},
	{350, "Rich Adamantite and Cobalt"},
	{375, "Khorium and Rich Cobalt"},
	{400, "Saronite"},
	{425, "Rich Saronite and Obsidium"},
	{450, "Rich Obsidium and Titanium"},
	{475, "Elementium"},
	{500, "Rich Elementium and Ghost Iron"},
	{525, "Pyrite and Rich Pyrite"},
	{550, "Rich Ghost Iron and Kyparite"},
	{575, "Rich Kyparite"},
	{600, "Trillium and Rich Trillium"}
}

local herbalism_levels = {
	{1, "Peacebloom, Silverleaf, Earthroot, and Mageroyal"},
	{70, "Briarthorn"},
	{85, "Stranglekelp and Bruiseweed"},
	{105, "Grave Moss"},
	{115, "Wild Steelbloom"},
	{125, "Kingsblood"},
	{150, "Liferoot, Fadeleaf, and Goldthorn"},
	{160, "Khadgar's Whisker"},
	{195, "Dragon's Teeth"},
	{205, "Firebloom"},
	{210, "Purple Lotus"},
	{220, "Arthas' Tears"},
	{230, "Sungrass"},
	{235, "Blindweed"},
	{245, "Ghost Mushroom"},
	{250, "Gromsblood"},
	{260, "Golden Sansam"},
	{270, "Dreamfoil"},
	{280, "Mountain Silversage"},
	{285, "Sorrowmoss"},
	{290, "Icecap"},
	{300, "Black Lotus and Felweed"},
	{315, "Dreaming Glory"},
	{325, "Terocone and Ragveil"},
	{335, "Flame Cap"},
	{340, "Ancient Lichen"},
	{350, "Netherbloom and Goldclover"},
	{360, "Fire Leaf"},
	{365, "Nightmare Vine"},
	{375, "Mana Thistle and Tiger Lily"},
	{385, "Talandra's Rose"},
	{400, "Adder's Tongue and Frozen Herb"},
	{425, "Lichbloom, Cinderbloom, Azshara's Veil, and Stormvine"},
	{435, "Icethorn"},
	{450, "Frost Lotus"},
	{475, "Heartblossom"},
	{500, "Whiptail"},
	{525, "Twilight Jasmine and Rain Poppy"},
	{545, "Silkweed"},
	{550, "Golden Lotus"},
	{575, "Snow Lily and Sha-Touched Herb"},
	{600, "Fool's Cap"}
}

local skinning_levels = {
	{1, "10"},
	{1, "11"},
	{20, "12"},
	{30, "13"},
	{40, "14"},
	{50, "15"},
	{60, "16"},
	{70, "17"},
	{80, "18"},
	{90, "19"},
	{100, "20"},
	{105, "21"},
	{110, "22"},
	{115, "23"},
	{120, "24"},
	{125, "25"},
	{130, "26"},
	{135, "27"},
	{140, "28"},
	{145, "29"},
	{150, "30"},
	{155, "31"},
	{160, "32"},
	{165, "33"},
	{170, "34"},
	{175, "35"},
	{180, "36"},
	{185, "37"},
	{190, "38"},
	{195, "39"},
	{200, "40"},
	{205, "41"},
	{210, "42"},
	{215, "43"},
	{220, "44"},
	{225, "45"},
	{230, "46"},
	{235, "47"},
	{240, "48"},
	{245, "49"},
	{250, "50"},
	{255, "51"},
	{260, "52"},
	{265, "53"},
	{270, "54"},
	{275, "55"},
	{280, "56"},
	{285, "57"},
	{290, "58"},
	{295, "59"},
	{300, "60"},
	{305, "61"},
	{310, "62"},
	{315, "63"},
	{320, "64"},
	{325, "65"},
	{330, "66"},
	{335, "67"},
	{340, "68"},
	{345, "69"},
	{350, "70"},
	{355, "71"},
	{360, "72"},
	{365, "73"},
	{375, "74"},
	{385, "75"},
	{395, "76"},
	{405, "77"},
	{415, "78"},
	{425, "79"},
	{435, "80"},
	{440, "81"},
	{445, "82"},
	{450, "83"},
	
	{455, "84"},
	{470, "85"},
	{485, "86"},
	{500, "87"},
	{520, "88"},
	{540, "89"},
	{560, "90"},
}

function GNGetHighest(skill,level)
	local tbl,ret
		if string.lower(skill) == "skinning" then tbl = skinning_levels
	elseif string.lower(skill) == "mining" then tbl = mining_levels
	elseif string.lower(skill) == "herbalism" then tbl = herbalism_levels
	  else return nil
	end
	
	for i,v in pairs(tbl) do
		if v[1] <= level then
			ret = v[2]
		end
	end
	
	return ret
end

function GNGetForLevel(skill,level)
	local tbl,ret
		if string.lower(skill) == "skinning" then tbl = skinning_levels
	elseif string.lower(skill) == "mining" then tbl = mining_levels
	elseif string.lower(skill) == "herbalism" then tbl = herbalism_levels
	  else return nil
	end
	
	for i,v in pairs(tbl) do
		if v[1] == level then
			ret = v[2]
		end
	end
	
	return ret
end

function GN_OnLoad(self)
	self:RegisterEvent("CHAT_MSG_SKILL")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
end

function GNTestError(skill,level)
	GN_OnEvent(nil,"UI_ERROR_MESSAGE",string.format("Requires %s %s",skill,level))
end

function GNTestLevelUp(skill,level)
	GN_OnEvent(nil,"CHAT_MSG_SKILL",string.format("Your skill in %s has increased to %s",skill,level))
end

function GN_OnEvent(self, event, ...)
	if (event == "CHAT_MSG_SKILL") then
		local skill = strmatch(...,"Your skill in (%a*) has increased to")
		local level = tonumber(strmatch(...,"Your skill in .* has increased to (%d*)"))
		
		if skill and level then
			local temp = 0
			local p = {}
			
			-- Get this profession's temporary boost, if any
			p[1],p[2],p[3],p[4],p[5],p[6] = GetProfessions()
			for i=1,6 do
				if p[i] then
					name,_,_,_,_,_,_,t = GetProfessionInfo(p[i])
					if name == skill then temp = t end
				end
			end
			
			----- First, print if you can mine something new, without taking temp bonuses into account -----
			local new = GNGetForLevel(skill,level)
			
			if new then
				local tempmsg = ""
				if temp>0 then tempmsg = " (without current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
				
					if skill == "Skinning"	then GN_Msg("Now able to skin level "..new.." creatures"..tempmsg,true)
				elseif skill == "Mining"	then GN_Msg("Now able to mine "..new..tempmsg,true)
				elseif skill == "Herbalism"	then GN_Msg("Now able to pick "..new..tempmsg,true)
				end
			end
			----- End -----
			
			----- Now, print if you can mine something new, WITH temp bonuses -----
			local newtemp = GNGetForLevel(skill,level+temp)
			
			if newtemp then
				local tempmsg = ""
				if temp>0 then tempmsg = " (with current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
				
					if skill == "Skinning"	then GN_Msg("Now able to skin level "..newtemp.." creatures"..tempmsg,true)
				elseif skill == "Mining"	then GN_Msg("Now able to mine "..newtemp..tempmsg,true)
				elseif skill == "Herbalism"	then GN_Msg("Now able to pick "..newtemp..tempmsg,true)
				end
			end
			----- End -----
		end
		
	elseif (event == "UI_ERROR_MESSAGE") then
		local skill = strmatch(...,"Requires (.*) ")
		local rlevel = tonumber(strmatch(...,"Requires .* (%d+)"))
		
		if ((skill ~= nil) and (rlevel ~= nil)) then -- Error was a "requires" error
			local p = {}
			local found = false
			p[1],p[2],p[3],p[4],p[5],p[6] = GetProfessions()
			
			for i=1,6 do
				if p[i] then
					name,_,current,_,_,_,_,temp = GetProfessionInfo(p[i])
					if name == skill then
						found = true
						GN_AddError(skill,rlevel,current,temp)
					end
				end
			end
			
			if found == false then
				UIErrorsFrame:AddMessage(...,1,.1,.1)
			end
		else
			UIErrorsFrame:AddMessage(...,1,.1,.1)
		end
	end
end

function GN_AddError(skill,rlevel,current,temp)
	if temp == 0 then
		UIErrorsFrame:AddMessage(string.format("Requires %s %s (currently %s)",skill,rlevel,current),1.0,0.1,0.1,1.0)
	else
		--UIErrorsFrame:AddMessage(string.format("Requires %s %s (currently %s - %s|cff1aff1a+%s|r)",skill,rlevel,current+temp,current,temp),1.0,0.1,0.1,1.0)
		UIErrorsFrame:AddMessage(string.format("Requires %s %s (currently %s|cff1aff1a+%s|r)",skill,rlevel,current,temp),1.0,0.1,0.1,1.0)
	end
end

function GN_Msg(msg,noname)
	if noname then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFC300"..msg)
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffd2b48c[GatherNotify]|r "..msg)
	end
end

SLASH_GN1, SLASH_GN2, SLASH_GN3 = '/gn', '/gathernotify', '/gnotify'
function SlashCmdList.GN(cmd)
	cmd = string.lower(cmd)
	if (cmd == "s" or cmd == "skinning") then
		GN_PrintHighest("skinning")
	elseif (cmd == "m" or cmd == "mining") then
		GN_PrintHighest("mining")
	elseif (cmd == "h" or cmd == "herbalism") then
		GN_PrintHighest("herbalism")
	elseif (cmd == "v" or cmd == "ver" or cmd == "version") then
		GN_Msg("GatherNotify version: "..GetAddOnMetadata("GatherNotify","Version"))
	else
		GN_Msg("/gn skinning - Print highest level creature you can skin")
		GN_Msg("/gn mining - Print highest node you can mine")
		GN_Msg("/gn herbalism - Print highest herb you can pick")
		GN_Msg("/gn version - Prints addon version")
	end
end

function GN_PrintHighest(skill)
	local p = {}
	local level
	local temp = 0
	local found = false
	p[1],p[2],p[3],p[4],p[5],p[6] = GetProfessions()
	
	for i=1,6 do
		if p[i] then
			name,_,level,_,_,_,_,temp = GetProfessionInfo(p[i])
			
			----- First, print highest mineable without taking temp bonuses into account -----
			local tempmsg = ""
			if temp>0 and GNGetHighest(skill,level+temp) ~= GNGetHighest(skill,level) then tempmsg = " (without current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
			if name == "Skinning" and skill == "skinning"	then found=true GN_Msg("Skinning "..level..": level "..GNGetHighest("skinning",level).." creatures"..tempmsg,true) end
			if name == "Mining" and skill == "mining" 		then found=true GN_Msg("Mining "..level..": "..GNGetHighest("mining",level)..tempmsg,true) end
			if name == "Herbalism" and skill == "herbalism"	then found=true GN_Msg("Herbalism "..level..": "..GNGetHighest("herbalism",level)..tempmsg,true) end
			----- End -----
			
			----- Then print highest mineable, taking temp bonuses into account -----
			if found==true then
				if GNGetHighest(skill,level+temp) ~= GNGetHighest(skill,level) then -- Only print what you can mine with current bonus if it differs from without bonus
					tempmsg = ""
					if temp>0 then tempmsg = " (with current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
					if name == "Skinning" and skill == "skinning"	then GN_Msg("Skinning |cff1aff1a"..level+temp.."|cffFFC300: level "..GNGetHighest("skinning",level+temp).." creatures"..tempmsg,true) end
					if name == "Mining" and skill == "mining" 		then GN_Msg("Mining |cff1aff1a"..level+temp.."|cffFFC300: "..GNGetHighest("mining",level+temp)..tempmsg,true) end
					if name == "Herbalism" and skill == "herbalism"	then GN_Msg("Herbalism |cff1aff1a"..level+temp.."|cffFFC300: "..GNGetHighest("herbalism",level+temp)..tempmsg,true) end
				end
			----- End -----
			end
		end
	end
	
	if found==false then
		GN_Msg("You don't have "..skill)
	end
end

function test(skill,level,temp)
	name = skill
	name = name:gsub("^%l", string.upper)
	
	
	----- First, print highest mineable without taking temp bonuses into account -----
	local tempmsg = ""
	if temp>0 and GNGetHighest(skill,level+temp) ~= GNGetHighest(skill,level) then tempmsg = " (without current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
	if name == "Skinning" and skill == "skinning"	then found=true GN_Msg("Skinning "..level..": level "..GNGetHighest("skinning",level).." creatures"..tempmsg,true) end
	if name == "Mining" and skill == "mining" 		then found=true GN_Msg("Mining "..level..": "..GNGetHighest("mining",level)..tempmsg,true) end
	if name == "Herbalism" and skill == "herbalism"	then found=true GN_Msg("Herbalism "..level..": "..GNGetHighest("herbalism",level)..tempmsg,true) end
	----- End -----
	
	----- Then print highest mineable, taking temp bonuses into account -----
	if found==true then
		if GNGetHighest(skill,level+temp) ~= GNGetHighest(skill,level) then -- Only print what you can mine with current bonus if it differs from without bonus
			tempmsg = ""
			if temp>0 then tempmsg = " (with current |cff1aff1a+"..temp.."|cffFFC300 bonus)" end
			if name == "Skinning" and skill == "skinning"	then GN_Msg("Skinning |cff1aff1a"..level+temp.."|cffFFC300: level "..GNGetHighest("skinning",level+temp).." creatures"..tempmsg,true) end
			if name == "Mining" and skill == "mining" 		then GN_Msg("Mining |cff1aff1a"..level+temp.."|cffFFC300: "..GNGetHighest("mining",level+temp)..tempmsg,true) end
			if name == "Herbalism" and skill == "herbalism"	then GN_Msg("Herbalism |cff1aff1a"..level+temp.."|cffFFC300: "..GNGetHighest("herbalism",level+temp)..tempmsg,true) end
		end
	----- End -----
	end
	
end